#include <iostream>
#include "seznam.h"

using namespace std;

int main()
{
	Seznam s1;
	cout << "=== Jednosmerne zretezeny seznam se zarazkou ===" << endl;
	vytvor_seznam(s1);
	cout << "Seznam vytvoren. Vkladani..." << endl;
	vloz_na_zacatek(s1, 4);
	vloz_na_zacatek(s1, 5);
	vloz_na_konec(s1, 10);
	cout << "Celkem prvku: " << velikost_seznamu(s1) << endl;
	odstran_prvni(s1);
	cout << "Celkem prvku: " << velikost_seznamu(s1) << endl;
	vyprazdni(s1);
	cout << "...vyprazdneno. Celkem prvku: " << velikost_seznamu(s1) << endl;

	vloz_na_konec(s1, 12);
	vloz_na_zacatek(s1, 138);
	vloz_na_zacatek(s1, 43);
	vloz_na_zacatek(s1, 204);
	vloz_na_konec(s1, 310);
	vloz_za_prvek(s1, 204, -17);
	cout << "Nove hodnoty v seznamu: ";
	vypis(s1);
	cout << "Celkem prvku: " << velikost_seznamu(s1) << endl;

	Prvek* prvek;
	T a = 1110;
	prvek = najdi(s1, a);
	cout << "Prvek " << a << (prvek ? " nalezen." : " nenalezen.") << endl; // informace o (ne)nalezeni
	prvek = minimum(s1);
	cout << "Minimum: " << prvek->data << endl;
	
	cout << "Upravy seznamu:" << endl;
	odstran_za(s1, s1.hlava); // odstrani cislo -17
	vypis(s1);
	vloz_za_prvek(s1, 204, 34); // vlozi cislo 34 (=> druhy prvek)
	vypis(s1);

	/* // kontrola spravnosti funkce "odstran_hodnotu":
	odstran_hodnotu(s1, 204); // prvni prvek
	vypis(s1);
	odstran_hodnotu(s1, 12); // prvek nekde uprostred
	vypis(s1);
	odstran_hodnotu(s1, 310); // posledni prvek
	vypis(s1);
	*/

	serad(s1);
	cout << "Serazeny seznam: ";
	vypis(s1);
		
	zrus(s1);
	cout << "Seznam zrusen." << endl;
}