#ifndef __SEZNAM_H__
#define __SEZNAM_H__
#include <string>
using namespace std;

using T = string;
const T NULA = T{}; // const T NULA = ""s;

struct Prvek
{
	T data;
	Prvek* dalsi;
};

struct Seznam
{
	Prvek* hlava;
	Prvek* zarazka;
	// size_t velikost;
};

struct Iterator_seznamu
{
	Prvek* aktualni_prvek;
	Seznam* s;
};


void vytvor_seznam(Seznam& s);
void vloz_na_zacatek(Seznam& s, T co);
void vloz_na_konec(Seznam& s, T co);
void odstran_prvni(Seznam& s);
bool prazdny(Seznam& s);
// size_t velikost_seznamu(Seznam& s);
void vyprazdni(Seznam& s);
void zrus(Seznam& s);
Iterator_seznamu najdi(Seznam& s, T hodnota); // Prvek* najdi(Seznam& s, T hodnota);
void vloz_za(T co, Iterator_seznamu kam);  // void vloz_za_prvek(Seznam& s, T hledane, T pridane);
void odstran_za(Iterator_seznamu kde); // void odstran_za(Seznam& s, Prvek* za_kterym);
void odstran(Iterator_seznamu kde); // void odstran_hodnotu(Seznam& s, T hodnota);
Iterator_seznamu minimum(Seznam& s); // Prvek* minimum(Seznam& s);
void vypis(Seznam& s);
void serad(Seznam& s);

void prohod(Seznam& s1, Seznam& s2);

Iterator_seznamu zacatek(Seznam& s);
Iterator_seznamu konec(Seznam& s);
void dalsi(Iterator_seznamu& kde);
T data(Iterator_seznamu kde);
void vloz_hodnotu(Iterator_seznamu kam, T co);
bool rovna_se(Iterator_seznamu a, Iterator_seznamu b);
bool nerovna_se(Iterator_seznamu a, Iterator_seznamu b);


#endif // __SEZNAM_H__
